var BOAT = {
	intro: "MAYDAY, I REPEAT, MAYDAY. WE ARE LOST. Out ship got attacked.",
	bg_room: "MAP",
	back: "MAP",
	current_cell_num: 0,
	current_cell: null,
	patrol_cells: [ 12, 13, 14, 10, 14, 13 ],
	patrol_cell: -1,
	pending_order: null,
	boatname: "HMS Wave",
	
	history: [],
	
	cells: {
		0:{
			message: "We need to go to port as soon as possible, this ship won't last long.",
			report: ["We are in some kind of golf, I see a big island to the south west 10 miles away.","I think... I can see something that looks like a cross on top of a mountain."],
			pos: [ 790, 290 ],
			actions: {
				N: "OUT",
				W: "OUT",
				E: { go: 1, after: "We crossed between two islands." },
				S: { go: 4 }
			}
		},
		1:{
			message: "We need directions.",
			report: "I can see the island with the cross to my south-west. There is another island to the north.",
			pos: [ 960, 300 ],
			actions: {
				N: "OUT",
				W: { go: 0 },
				E: { go: 2 },
				S: "MINES"
			}
		},
		2:{
			message: "We hear some transmissions in 400KHz band.",
			report: "There are not much landmarks here... all I see is some rock formation 7 miles east from our position.",
			pos: [ 1100, 290 ],
			actions: {
				N: "OUT",
				W: { go: 1 },
				E: "PATROL",
				S: { go: 6 }
			}
		},
		4: {
			message: "Damn, this area is full of birds...",
			report: "We are between two islands, this area is full of filthy birds...",
			pos: [ 790, 455 ],
			actions: {
				N: { go: 0 },
				W: "OUT",
				E: { go: 5 },
				S: { go: 8 }
			}
		},	
		5: {
			message: "This is getting harder than we expected...",
			report: "There is a big island south-east of us, it has the shape of a claw.",
			pos: [ 960, 455 ],
			actions: {
				N: "MINES",
				W: { go: 4 },
				E: "MINES",
				S: { go: 9 }
			}
		},
		6: {
			message: "One of our engines is almost dead.",
			report: "We are in the middle of three islands, but I can't say any remarkable feature. But the waters here have a strange color.",
			pos: [ 1120, 455 ],
			actions: {
				N: { go: 2 },
				W: "MINES",
				E: "PATROL",
				S: { go: 10 }
			}
		},
		8: {
			message: "One of our crew requires medical attention.",
			report: "There is a big island to the south... but it seems hard to navigate.",
			pos: [ 795, 619 ],
			actions: {
				N: { go: 4 },
				W: "OUT",
				E: { go: 9 },
				S: "CRASH"
			}
		},	
		9: {
			message: "",
			report: "I'm in some kind of golf, there is islands in all directions. I can see lots of rocks to the south, it could be dangerous to go in that direction.",
			pos: [ 950, 619 ],
			actions: {
				N: { go: 5 },
				W: { go: 8 },
				E: { go: 10 },
				S: "CRASH"
			}
		},
		10: {
			message: "",
			report: "We are in deep sea, we cannot see land from here.",
			pos: [ 1100, 619 ],
			actions: {
				N: { go: 6 },
				W: { go: 9 },
				E: { go: 11 },
				S: { go: 14 }
			}
		},
		11: {
			message: "",
			report: "I see lights to the south! We must be close.",
			pos: [ 1270, 619 ],
			actions: {
				N: "PATROL",
				W: { go: 10 },
				E: { go: 10 },
				S: "WIN"
			}
		},
		12: {
			pos: [ 828, 773 ],
		},
		13: {
			pos: [ 964, 746 ],
		},
		14: {
			message: "I think we are close...",
			report: "I see lights to the east! We must be close.",
			pos: [ 1100, 770 ],
			actions: {
				N: "PATROL",
				W: "CRASH",
				E: "WIN",
				S: "OUT"
			}
		}	
	},
	
	oninit: function()
	{
		this.history.length = 0;
		this.current_order = null;
		this.moveTo(0);
		this.movePatrol();
	},
	
	ondraw: function(ctx)
	{
		ctx.save();
		ctx.translate( MAP.sprites[0].position[0], MAP.sprites[0].position[1] );
	
		var boat_pos = this.current_cell.pos;
		
		ctx.fillStyle = "green";
		ctx.fillRect( boat_pos[0] - 10, boat_pos[1] - 10, 20,20 );

		var boat_pos = this.cells[ this.patrol_cell ].pos;
		if(boat_pos)
		{
			ctx.fillStyle = "red";
			ctx.fillRect( boat_pos[0] - 10, boat_pos[1] - 10, 20,20 );
		}
		
		var boat_pos2 = this.cells[ this.patrol_cells[0] ].pos;
		if(boat_pos2)
		{
			ctx.strokeStyle = "red";
			ctx.beginPath();
			ctx.moveTo( boat_pos[0], boat_pos[1]  );
			ctx.lineTo( boat_pos2[0], boat_pos2[1] );
			ctx.stroke();
		}
		
		ctx.restore();
		
	},
	
	moveTo: function( cell_num )
	{
		this.current_cell_num = cell_num;
		this.current_cell = this.cells[ this.current_cell_num ];
		this.history.push( cell_num );
		console.log( "Im now in ", cell_num );
	},

	movePatrol: function()
	{
		this.patrol_cell = this.patrol_cells.shift();
		this.patrol_cells.push( this.patrol_cell ); //circle waypoints
		console.log( "Patrol now in ", this.patrol_cell );
	},
	
	giveOrder: function( order, answer_text )
	{
		var received = Math.random() < 0.7;
		
		if(!received)
			return;
			
		this.pending_order = order;
		
		var answer = Math.random() < 0.9;
		if(!answer)
			return;

		setTimeout( function(){ 
			GAME.onRadioSays("HMS: - OK, MESSAGE RECEIVED, " + answer_text );
		},4000);
	},
	
	onmousemove: function(e)
	{
		MAP.onmousemove(e);
	},
	
	onTurn: function( num )
	{
		this.movePatrol();
		var r = this.executeCommand( this.pending_order );
		
		//captured
		if(this.current_cell == this.patrol_cell)
		{
			GAME.finish( "PATROL" );
			return true;
		}
		
		return r;
	},
	
	executeCommand: function( order )
	{
		var cell = this.current_cell;
		if(!cell)
			throw("no current cell");
		
		if(!order)
		{
			console.log("no orders given");
			return;
		}
			
		var action = cell.actions[ order ];
		if(!action)
		{
			console.log("this cell doesnt have that action");
			return;
		}
		
		if( action.constructor == String )
		{
			GAME.finish( action );
			return true;
		}
			
		if( action.go !== undefined )
		{
			console.log("Moving to ", action.go );
			this.moveTo( action.go );
		}
			
		console.log( this.current_cell.report );
	},
	
	getBoatReport: function()
	{
		if(!this.current_cell)
			return "unknown";
		var report = [ BOAT.boatname + " reporting: " ].concat( this.current_cell.report );
		report.push( "End of report" );
		return report;
	},
	
	getCellLongLat: function( num )
	{
		var cell = this.cells[ num ];
		if(!cell)
		{
			console.log("unknown cell");
			return [0,0];
		}
		
		var pos = cell.pos;
		if(!pos)
		{
			console.log("cell without pos");
			return [0,0];
		}
		
		//long 10 -> 712 y long 14 -> 1353
		//lat 55 -> 219 y lat 51 -> 860
		
		var long = ((pos[0] - 712) / (1353 - 712)) * (14-10) + 10;
		var lat = ((pos[1] - 219) / (860 - 219)) * (51-55) + 55;
		return [long,lat];
	}
	
}

GAME.rooms["BOAT"] = BOAT;