var GAME = {

	current_room: null,
	last_mouse_down: [0,0],
	rooms: {},
	turn: 0,
	room_time: 0,

	init: function()
	{
		/*
		var scene = this.scene = new RD.Scene();
		
		this.content = new RD.SceneNode()
		scene.root.addChild( this.content );
		
		//create a mesh in the scene
		var frame = new RD.Sprite({
			texture: "frame.png"
		});
		scene.root.addChild( frame );

		this.hud = new RD.SceneNode()
		scene.root.addChild( this.hud );
		*/
	},
	
	start: function()
	{
		this.turn = 0;
		
		for(var i in this.rooms)
		{
			var room = this.rooms[i];
			if( room.oninit )
				room.oninit();
			//preload
			for(var j in room.sprites)
			{
				var sprite = room.sprites[j];
				if(sprite.texture)
					GFX.getImage( sprite.texture );
				if(sprite.texture_over)
					GFX.getImage( sprite.texture_over );
			}
		}
		
		GFX.logs.length = 0;
		this.setRoom( "INTRO" );
		//this.setRoom( "RADIO" );
		
		GFX.showText(["Another boring day at the radio station..."]);

	},
	
	setRoom: function( name )
	{
		//	var scene = GFX.scene = this.scene;
		
		var room_info = this.rooms[ name ];
		if( !room_info )
			throw("not found room", name);
		room_info.id = name;
		
		var old = this.current_room;
		if(this.current_room && this.current_room != room_info && this.current_room.onleave )
			this.current_room.onleave( room_info );

		this.current_room = room_info;
		this.room_time = 0;
		
		if(this.current_room.onenter)
			this.current_room.onenter( old );
		
		if( room_info.intro_text )
			GFX.showText( room_info.intro_text ); 
	},
		
	update: function(dt)
	{
		if(this.current_room)
		{ 
			this.room_time += dt;
			if(this.current_room.onupdate)
				this.current_room.onupdate(dt);
		}
	},

	onmousedown: function( e )
	{
		this.last_mouse_down[0] = e.canvasx;
		this.last_mouse_down[1] = e.canvasy;
		
		var sprite = this.getSpriteOnMouse();
		this.mousedown_sprite = sprite;
		if( sprite && sprite.action )
		{
			eval( sprite.action );
			return;
		}
		
		if(this.current_room && this.current_room.onmousedown)
			this.current_room.onmousedown(e);
	},
	
	onmousemove: function(e)
	{
		if(this.current_room && this.current_room.onmousemove)
			this.current_room.onmousemove(e);
	},
	
	onmouseup: function(e)
	{
		this.mousedown_sprite = null;
		if(this.current_room && this.current_room.onmouseup)
			this.current_room.onmouseup(e);
	},
	
	onTurn: function()
	{
		var endgame = false;
		this.turn += 1;
		for(var i in this.rooms)
		{
			var room = this.rooms[i];
			if( room.onTurn )
			{
				if( room.onTurn( this.turn ) == true )
					return;
			}
		}
		
		GFX.logs.length = 0;
		if( this.discovered )
			GFX.showText( ["I must help the " + BOAT.boatname + " to reach the station!","I should contact them."] );
		GAME.setRoom("DESK");		
	},	
	
	onOperatorSays: function( msg, time )
	{
		GFX.showText( msg );
	},
	
	onOperatorSendOrder: function( order )
	{
		var msg = order;
		var order_answer = order;
		switch( order )
		{
			case "REPORT": msg = "- Here the Radio Station, please REPORT status."; break;
			case "N": msg = "- You must go NORTH. Please CONFIRM."; order_answer = "Going NORTH"; break;
			case "S": msg = "- You must go SOUTH. Please CONFIRM."; order_answer = "Going SOUTH"; break;
			case "E": msg = "- You must go EAST. Please CONFIRM."; order_answer = "Going EAST"; break;
			case "W": msg = "- You must go WEST. Please CONFIRM."; order_answer = "Going WEST"; break;
			case "WAIT": msg = "- You must WAIT in those coordinates. Please CONFIRM."; order_answer = "Waiting"; break;
		}
		
		GFX.showText( msg );
		
		var signal = RADIO.getSignalWith( "mayday");		
		if(signal < 0.2)
			return; //nobody hear you
		
		if(order == "REPORT")
		{
			setTimeout( function(){ 
				GFX.showText( BOAT.getBoatReport() );
			}, 2000 + Math.random() * 2000);
		}
		else
			BOAT.giveOrder( order, order_answer );
	},
	
	onRadioSays: function( msg, time )
	{
		GFX.showText( msg );
	},
	
	onListenMayday: function()
	{
		if(!this.discovered)
		{
			this.discovered = true;
			GFX.showText( ["This is a MAYDAY signal!! ",
							"The "+BOAT.boatname+" has been attacked.",
							"It requests help to guide him here.",
							"I must contact him."] );
		}
		else
		{
			GFX.showText( "I can hear the mayday signal from " + BOAT.boatname );
		}
	},
	
	onDiscoverPatrol: function()
	{
		if(BOAT.patrol_cell == 1)
		{
			throw("patrol in unknown cell");
			return;
		}
		
		var coord = BOAT.getCellLongLat( BOAT.patrol_cell );
		var next_coord = BOAT.getCellLongLat( BOAT.patrol_cells[0] );
		console.log("Patrol detected at", coord[0], coord[1] );
		console.log("moving to", next_coord[0], next_coord[1] );
		
		var delta_long = next_coord[0] - coord[0];
		var delta_lat = next_coord[1] - coord[1];
		var dir = "unknown";
		
		if( Math.abs(delta_long) > Math.abs(delta_lat) )
			dir = delta_long > 0 ? "EAST" : "WEST";
		else
			dir = delta_lat > 0 ? "NORTH" : "SOUTH";
		
		GAME.onOperatorSays([
			"This is an enemy signal!! They are sending their coordinates.",
			"Their LONGITUDE is " + coord[0].toFixed(1) + " and their LATITUDE is " + coord[1].toFixed(1),
			"They are moving "+ dir +" to " + next_coord[0].toFixed(1) + ", " + next_coord[1].toFixed(1)
		]);

	},
	
	finish: function( ending )
	{
		if(ending == "OUT")
		{
			console.log("We lose contact with the ship");		
		}
		else if(ending == "CRASH")
		{
			console.log(" - MAYDAY!! WE ARE SINKING!! We hit some rocks...");		
		}
		else if(ending == "PATROL")
		{
			console.log(" - We are surrounded by enemy ships... We are captured.");		
		}
		else if(ending == "MINES")
		{
			console.log(" The ship got hit by a mine and sunk");		
		}
		else if(ending == "WIN")
		{
			console.log(" - We made it!! we are finally safe!!");		
		}
		
		for(var i in this.rooms)
		{
			var room = this.rooms[i];
			if( room.onFinish )
				room.onFinish( this.turn );
		}

		
		END.ending = ending;
		GAME.setRoom( "END" );
		
		//this.start();
	},
	
	getSpriteOnMouse: function()
	{
		var room = GAME.current_room;
		if(!room)
			return;
			
		var mouse = GFX.loop.mouse;
		
		for(var i in room.sprites)
		{
			var sprite = room.sprites[i];
			var pos = sprite.position || [0,0];
			if( sprite.area )
			{
				if( mouse.isInsideRect( pos[0] + GFX.offset[0], pos[1] + GFX.offset[1], sprite.area[0], sprite.area[1], true  ) )
					return sprite;
			}
		}
		
		return null;
	}
};

function doAction( action, param1, param2 )
{
	switch( action )
	{
		case "CHANGE_ROOM": GAME.setRoom( param1 ); break;
		case "TALK": GAME.onTalk(); break;
		case "LISTEN_MAYDAY": GAME.onListenMayday(); break;
		case "DISCOVER_PATROL": GAME.onDiscoverPatrol(); break;
		case "DO_TURN": GAME.onTurn(); break;
		case "START": GAME.start(); break;
		default: console.log("unkown action", action);
	}
}


