var NET = {

	connected: false,
	server: null,
	debug: true,

	init: function()
	{
		this.server = new SillyClient();
		this.server.connect( location.host + ":55000", "RADIO");
		this.server.on_ready = function( id ){
		  //connected
		  NET.username = "operator_" + id;
		  NET.connected = true;
		  console.log("NET","Server ready!","#475");
		};

		this.server.on_close = function(){
		  //disconnected
		  NET.connected = false;
		  console.log("NET","Server closed...","#475");
		};

		this.server.on_message = NET.processMessage.bind( NET );
	},

	sendChat: function( content, freq )
	{
		if(!this.server)
			return;

		var msg = { author: NET.username, type: "chat", freq: freq, content: content };
		this.server.sendMessage( msg );
	},

	processMessage: function( author_id, json_msg )
	{
		var msg = JSON.parse( json_msg );
		var content = document.createElement("span");
		content.innerText = msg;
		switch(msg.type)
		{
			case "chat": this.onOperatorMessage(msg); break;
			default: break;
		}
	},
	
	onOperatorMessage: function(msg)
	{
		if(this.debug)
			console.log( msg.author, msg.content );
		var dist = ( 1.0 - Math.abs( GAME.rooms.radio.freq - msg.freq ) / 50 );
		if(dist < 0)
			return;
			
		var str = "";
		for(var i = 0; i < msg.content.length; ++i)
			if( Math.random() > dist )
				str += "..";
			else
				str += msg.content[i];
		GAME.onRadioSays( [str] );
	}
}